#include "wx/wxprec.h"

#include "stdio.h"

#ifndef WX_PRECOMP
#include "wx/wx.h"
#endif

#include "asyncprocess.h"

DEFINE_LOCAL_EVENT_TYPE(wxEVT_PROCESS_STDOUT);

IMPLEMENT_DYNAMIC_CLASS(AsyncProcess, wxProcess)

AsyncProcess::AsyncProcess(): m_pEvtHandler(NULL) {
}

AsyncProcess::AsyncProcess(wxEvtHandler *evtHandler) : wxProcess(), wxThreadHelper(), m_pEvtHandler(evtHandler) {
	Redirect();
}

void AsyncProcess::start() {
	int pid;
	const wxString cmd = wxT("/usr/bin/nxssh -nx -x -2 -p 2222 -o 'RhostsAuthentication no' -o 'PasswordAuthentication no' -o 'RSAAuthentication no' -o 'RhostsRSAAuthentication no' -o 'PubkeyAuthentication yes' -i /usr/lib64/opennx/share/keys/server.id_dsa.key -B -E nx@192.168.4.58");
	pid = wxExecute(cmd, wxEXEC_ASYNC, this);
	printf("pid: %d\n",pid);
	Create();
	m_thread->Run();
}

wxThread::ExitCode AsyncProcess::Entry() {
	while (!m_thread->TestDestroy()) {
		while (IsInputAvailable()) {
			char c = GetInputStream()->GetC();
			printf("%c", c); 
			if(c == '\n') {
				wxCommandEvent event(wxEVT_PROCESS_STDOUT, wxID_ANY);
				event.SetString(_T("String complete\n"));
				event.SetClientData(this);
				m_pEvtHandler->AddPendingEvent(event);
			}
		}
	}
}

AsyncProcess::~AsyncProcess() {
}

void AsyncProcess::OnTerminate(int pid, int status) {
}

